<html lang="en">
<head>
<title>Introduction - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="index.html#Top" title="Top">
<link rel="next" href="CLOS-compatibility.html#CLOS-compatibility" title="CLOS compatibility">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Introduction"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="CLOS-compatibility.html#CLOS-compatibility">CLOS compatibility</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="index.html#Top">Top</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">1 Introduction</h2>

<p>EIEIO is a CLOS (Common Lisp Object System) compatibility layer.  Due
to restrictions in the Emacs Lisp language, CLOS cannot be completely
supported, and a few functions have been added in place of setf.

<h3 class="section">1.1 What EIEIO supports</h3>

     <ol type=1 start=1>
<li>A structured framework for the creation of basic classes with attributes
and methods using singular inheritance similar to CLOS. 
<li>Type checking, and slot unbinding. 
<li>Method definitions similar to CLOS. 
<li>Simple and complex class browsers. 
<li>Edebug support for methods. 
<li>Imenu updates. 
<li>Byte compilation support of methods. 
<li>Help system extentions for classes and methods. 
<li>Automatic texinfo documentation generator. 
<li>Several base classes for interesting tasks. 
<li>Simple test suite. 
<li>Public and private classifications for slots (extensions to CLOS)
<li>Customization support in a class (extension to CLOS)
     </ol>

<h3 class="section">1.2 Issues using EIEIO</h3>

     <dl>
<dt>Complete <code>defclass</code> tag support<dd>All CLOS tags are currently supported, but some are not currently
implemented correctly. 
<br><dt>Mock object initializers<dd>Each class contains a mock object used for fast initialization of
instantiated objects.  Using functions with side effects on object slot
values can potentially cause modifications in the mock object.  EIEIO
should use a deep copy but currently does not. 
<br><dt>:AROUND method tag<dd>This CLOS method tag is non-functional. 
</dl>

<h3 class="section">1.3 EIEIO example programs that are almost useful.</h3>

     <dl>
<dt>linemark<dd>Manage line highlighting, where individual lines are given a
background color, or some other graphic feature.  Lines can be
highlighted in files not currently loaded in Emacs.  When they are
read in, the lines are given the graphic properties.

     <p>Includes an MS Visual Studio like bookmark facility. 
<br><dt>lmcompile<dd>Using linemark, highlight all lines where the latest compilation
has valid hits. 
<br><dt>tree<dd>Draw a structured tree by building a series of embedded lists of
`tree-node' class objects.  Includes the functions `eieio-class-tree' to
browse your current eieio inheritance structure
<br><dt>call-tree<dd>Pass it an Emacs Lisp function (not byte compiled) to generate a call tree
using the tree tool
<br><dt>chart<dd>Uses eieio to manage charts/axis/sequences, and allows display of simple
bar-charts.  Example programs are available displaying emacs memory
usage and list occupation, in addition to file counts and size charts. 
There's even a sample that will display a chart of who sends you the most
email!  See doc-string for `chart-bar-quickie' to make your own bar
charts easily. 
<br><dt>eieio-speedbar<dd>Classes for implementing a speedbar display.  If you write a program
that uses a system of objects, and your classes inherit from those in
<samp><span class="file">eieio-speedbar</span></samp>, then you can write a speedbar display for your
objects in very little time. <a href="eieio_002dspeedbar.html#eieio_002dspeedbar">eieio-speedbar</a>
</dl>

<h3 class="section">1.4 EIEIO wish list</h3>

     <ol type=1 start=1>
<li>More CLOS compatibility. 
<li>Integrate the desired built-in methods into the object browser. 
<li>Create some objects over pre-existing emacs-lisp stuff for fun, like
faces, processes, buffers, frames and windows as examples.
     </ol>

   </body></html>

